.module       MYEFFECT;

.include <system.k>;
.include <midi.k>;

.global         handle_MIDI_controller;
.external       process_midi;
.external       rx_buf,tx_buf;
.global         main_loop,input_samples,init_params;

{ signal processing variables here }


{ internal variables }
.var last_input;
.var last_output;
.init last_output:0;

{ parameters here }

{ do any dynamic memory/variable initializing you need to here }
init_params:
        nop;
        nop;
        nop;
        rts;

{ command loop - check for incoming data on serial port }
main_loop:
        ar = dm (CHAR_WAITING_FLAG);    { check serial port for MIDI data }
        none = pass ar;
        if ne jump main_loop;
        call process_midi;        { if MIDI byte received }
        jump main_loop;




{ SPORT0 interrupt handler -- this is called at 44.1KHz }
input_samples:
        ena sec_reg;                { use shadow register bank }

        my0 = dm(rx_buf +1);    { read a/d converters }
        my1 = dm(rx_buf +2);    { leave left/right values in my0,my1 }




        { insert your DSP code here }              




        dm(tx_buf+ 1)=my0;      { write d/a converters }
        dm(tx_buf+ 2)=my1;      { write left/right values from my0, my1 }

        { save output value (for possible feedback) }
        dm(last_output)=mr1;
        
thatwasfun:
        rti;    





{ Here is where MIDI messages are used to set variables in your Effect! }
handle_MIDI_controller:
        ax1 = dm(midi_cont);
        ar  = dm(midi_val);
        ay1 = 1;none = ax1-ay1;if eq jump set_blah1;
        ay1 = 127;none = ax1-ay1;if eq jump set_blah127;
        rts;

set_blah1:
        ay1 = dm(midi_val);
        rts;

set_blah127:
        ay1 = dm(midi_val);
        rts;



.endmod;
